from autoPhrase import *

#Binary relation.
thingSimp('BR','1','binary relation','')

#Ternary relation.
thingSimp('TR','1','ternary relation','')

#Domain.
func('Dom','1','',
  'the domain of #0'
)

#Range.
func('Rng','1','',
  'the range of #0'
)

#Field.
func('Fld','1','',
  'the field of #0'
)

#Converse relation.
func('Cnv','1','',
  'the converse relation to #0'
)

#Composition of relations.
infixFunc('\\circ','$\\circ$',
  'the composition of #0 following #1'
)

#Restriction of relations.
verbatim(
r"""|:infix@
  symb:#0 $|$ #1@
  word:the restriction of #0 to #1@@
""")

#Range of restricted relation.
verbatim(
r"""|_{Rng}:infix@
  word:the range of #0 when restricted to #1@@
""")

#Reflexive.
adj('RFX','2','#0','reflexive','on #1')

#Irreflexive.
adj('IRFX','2','#0','irreflexive','on #1')

#Symmetric.
adj('SYM','2','#0','symmetric','on #1')

#Asymmetric.
adj('ASYM','2','#0','asymmetric','on #1')

#Antisymmetric.
adj('ANSYM','2','#0','antisymmetric','on #1')

#Transitive.
adj('TRAN','2','#0','transitive','on #1')

#Connected.
adj('CONN','2','#0','connected','on #1')

#Simply connected.
adj('SCONN','2','#0','simply connected','on #1')

#Now the same 8 again, only relativised to their own domains:

#Reflexive.
adj('RFX','1','#0','reflexive','')

#Irreflexive.
adj('IRFX','1','#0','irreflexive','')

#Symmetric.
adj('SYM','1','#0','symmetric','')

#Asymmetric.
adj('ASYM','1','#0','asymmetric','')

#Antisymmetric.
adj('ANSYM','1','#0','antisymmetric','')

#Transitive.
adj('TRAN','1','#0','transitive','')

#Connected.
adj('CONN','1','#0','connected','')

#Simply connected.
adj('SCONN','1','#0','simply connected','')

#Identity function.
func('Id','1','$Id(#^0)$','the identity function on #0')

#Quasi order?
thingSimp('QORD','2','quasi order','on #1')

#Partial order.
thingSimp('PORD','2','partial order','on #1')

#Simple order.
thingSimp('SORD','2','simple order','on #1')

#Strict partial order.
thingSimp('SPORD','2','strict partial order','on #1')

#Strict simple order.
thingSimp('SSORD','2','strict sipmle order','on #1')

#Same 5, only unary now:

#Quasi order?
thingSimp('QORD','1','quasi order','')

#Partial order.
thingSimp('PORD','1','partial order','')

#Simple order.
thingSimp('SORD','1','simple order','')

#Strict partial order.
thingSimp('SPORD','1','strict partial order','')

#Strict simple order.
thingSimp('SSORD','1','strict sipmle order','')

#Minimal element.
thingSimp('MELT','3','minimal element','in #2, under #1')

#First element.
thingSimp('FELT','3','first element','in #2, under #1')

#Well-order.
thingSimp('WO','2','well-ordering','on #1')

#Immediate successor.
thingSimp('ISUC','3','immediate successor','of #2, under #1')

#Last element.
thingSimp('LELT','3','last element','in #2, under #1')

#Section.
thingSimp('SECT','3','section','of #2, under #1')

#Segment.
func('Seg','3','',
  'the initial segment of #0 at #2, under #1'
)

#Lower bound.
thingSimp('LB','3','lower bound','for #2, under #1')

#Infimum.
thingSimp('INF','3','infimum','for #2, under #1')

#Upper bound.
thingSimp('UB','3','upper bound','for #2, under #1')

#Supremum.
thingSimp('SUP','3','supremum','for #2, under #1')

#Equivalence relation.
thingSimp('EQUIV','1','equivalence relation','')

#Equivalence relation on A.
thingSimp('EQUIV','2','equivalence relation','on #1')

#Coset.
func('Coset','2','','the coset of #0 with respect to #1')

#Partition of A.
thingSimp('PART','2','partition','of #1')

#Partition.
thingSimp('PART','1','partition','')

#Finer than relation for partitions.
relnPrep('FINER','2','','finer than','')

#Partition function.
func('Part','1','','the partition induced by #0')

#Relation induced by a partition.
func('Reln','1','','the relation induced by #0')

#Property of being a function.
thingSimp('FCN','1','function','')

#Monomorphic function.
thingSimp('MONO','1','injection','')

#Function from A to B.
thingSimp('FCN','3','function','from #1 to #2')

#Surjection from A to B.
thingSimp('SURJ','3','surjection','from #1 to #2')

#Injection from A to B.
thingSimp('MONO','3','injection','from #1 to #2')

#Bijection from A to B.
thingSimp('BIJ','3','bijection','from #1 to #2')

#Set of maps.
func('Maps','2','','the set of maps from #0 to #1')
















